import { EventObject, StateMachine, State, Interpreter, InterpreterOptions, MachineOptions, StateConfig } from 'xstate';
interface UseMachineOptions<TContext, TEvent extends EventObject> {
    /**
     * If provided, will be merged with machine's `context`.
     */
    context?: Partial<TContext>;
    /**
     * If `true`, service will start immediately (before mount).
     */
    immediate: boolean;
    /**
     * The state to rehydrate the machine to. The machine will
     * start at this state instead of its `initialState`.
     */
    state?: StateConfig<TContext, TEvent>;
}
export declare function useMachine<TContext, TEvent extends EventObject>(machine: StateMachine<TContext, any, TEvent>, options?: Partial<InterpreterOptions> & Partial<UseMachineOptions<TContext, TEvent>> & Partial<MachineOptions<TContext, TEvent>>): [State<TContext, TEvent>, Interpreter<TContext, any, TEvent>['send'], Interpreter<TContext, any, TEvent>];
export declare function useService<TContext, TEvent extends EventObject>(service: Interpreter<TContext, any, TEvent>): [State<TContext, TEvent>, Interpreter<TContext, any, TEvent>['send'], Interpreter<TContext, any, TEvent>];
export { useActor } from './useActor';
//# sourceMappingURL=index.d.ts.map